import logging
import sys

from peewee import MySQLDatabase, SqliteDatabase


LOG_FORMAT = '%(asctime)-15s - %(levelname)s - %(pathname)s - ' + \
             '%(funcName)s - %(message)s'


class FlaskConfig(object):
  SECRET_KEY = '1cb18882-6d12-440d-a4cc-b7430fb5f884'


class MailConfig(object):
  MAIL_SERVER = 'email-smtp.us-east-1.amazonaws.com'
  MAIL_USE_TLS = True
  MAIL_PORT = 587
  MAIL_USERNAME = 'AKIAIXV5SDGCPVMU3N4Q'
  MAIL_PASSWORD = 'AhmX/vWE91uQ2RtcEKTkfNrzZehEjPNXOXeOXgQNfLao'
  DEFAULT_MAIL_SENDER = 'support@fluxmonkey.io'
  MAIL_FAIL_SILENTLY = False
  TESTING = False


class SQLiteDB(object):
  DB_NAME = 'test.db'
  DB_CONNECTION_ARGS = {
    'threadlocals': True
  }
  DB_DRIVER = SqliteDatabase


class RDSMySQL(object):
  DB_NAME = 'quay'
  DB_CONNECTION_ARGS = {
    'host': 'fluxmonkeylogin.cb0vumcygprn.us-east-1.rds.amazonaws.com',
    'user': 'fluxmonkey',
    'passwd': '8eifM#uoZ85xqC^',
    'threadlocals': True,
  }
  DB_DRIVER = MySQLDatabase


class S3Storage(object):
  AWS_ACCESS_KEY = 'AKIAJWZWUIS24TWSMWRA'
  AWS_SECRET_KEY = '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'
  REGISTRY_S3_BUCKET = 'quay-registry'
  STORAGE_KIND = 's3'


class LocalStorage(object):
  STORAGE_KIND = 'local'
  LOCAL_STORAGE_DIR = '/tmp/registry'


class DebugConfig(FlaskConfig, MailConfig, LocalStorage, SQLiteDB):
  REGISTRY_SERVER = 'localhost:5000'
  LOGGING_CONFIG = {
    'level': logging.DEBUG,
    'format': LOG_FORMAT
  }


class ProductionConfig(FlaskConfig, MailConfig, S3Storage, RDSMySQL):
  REGISTRY_SERVER = 'quay.io'
  LOGGING_CONFIG = {
    'stream': sys.stderr,
    'level': logging.DEBUG,
    'format': LOG_FORMAT,
  }
